<?php

namespace Teknisa\FIN\Modules\ContaPagar\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\FIN\Controllers\TeknisaCrud;
use Teknisa\Libs\Service\CRUD as CrudService;
use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\ParameterBag;
use Geral\Util\DateUtil;
use Teknisa\FIN\Modules\ContaPagar\Services\Pag18000CompensacaoTitulosPagarService;

class Pag18000CompensacaoTitulosPagarController extends TeknisaCrud{

    protected $dataSourceName = 'compensacontpag_compensacaoPagar';
    protected $parameterBagColumns = array(
        "CDEMPRESA", "TCDOPERADOR", "CDOPERADOR", "TCDFORNECED", "CDFORNECED", "NRORG",
        "CONTAFILTRO", "TCDREDUCONT", "DATAINI", "DATAFIN", "TVALOR", "VALORINI", "CDREDUCONT",
        "VALORFIN", "TTIPO", "CDTPDEBIBANC", "TDATA", "STATUS", "NRDUPLICATA", "IDPROTESTREC", "NRLANCCOMPPAG",
        "CDNOSNUMREC", "FILILANC", "FILIORIG", "DOCINICIAL", "DOCFINAL", "TCDCLIENTE", "CDCLIENTE",
        "CDTPBAIXAREC", "DATAINICIAL", "DATAFINAL", "VALORINICIAL", "VALORFINAL", "TVALOR"
        );
    protected $environment;
    protected $entityManager;
    protected $services;

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()));
        $this->dataSourceName = $dataSource;
        parent::find($request, $response);
    }

    public function __construct($crudService, ParameterBag $parameterBag, Environment $environment,
                                Pag18000CompensacaoTitulosPagarService $services, EntityManager $entityManager){
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->services = $services;
        $this->entityManager = $entityManager;
    }

    public function saveCompensacaoPagar(DTO\Request $request, DTO\Response $response){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try{
            $rows = $request->getDataSet()->getRows();
            $nrorg = $this->environment->getNrOrgTrab();
            $operador = $this->environment->getCdOperador();
            $rowPagar = $rows[0];
            unset($rows[0]);
            $rowsReceber = $rows;
            $this->services->geraCompensacao($rowPagar, $rowsReceber);
            $this->entityManager->flush();
            $connection->commit();
        }catch(\Exception $e){
            $connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }

    public function deleteCompensacaoPagar(DTO\Request $request, DTO\Response $response){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try{
            $rows = $request->getDataSet()->getRows();
            $compensacaoPagar = $rows[0];
            unset($rows[0]);
            $contaReceber = $rows;
            $this->services->deleteCompensacaoPagar($compensacaoPagar, $contaReceber);
            $this->entityManager->flush();
            $connection->commit();
        }catch(\Exception $e){
            $connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}