<?php

namespace Teknisa\FIN\Modules\ContaPagar\Services\RetornoDDA;

class LeitorCnabBradesco{

    private $cnpjEmpresa;
    CONST ID_REGISTRO_HEADER = '0';
    CONST ID_REGISTRO_LOTE = '1';
    CONST ID_REGISTRO_TRANSACAO = '3';
    CONST ID_REGISTRO_TRAILLER_LOTE = '5';
    CONST ID_REGISTRO_TRAILLER = '9';

    CONST CODIGO_COMPENSACAO_BRADESCO = '237';
    CONST CPF = '1';
    CONST SEGMENTO_I = 'I';
    CONST SEGMENTO_J = 'J';

    protected $retornos = array();

    public function __construct($arquivo, $cdbanco){
        try {
            $this->cdbanco = $cdbanco;
            $this->arquivo = $arquivo;
            $this->existeBoleto = false;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getRetornos(){
        $boletos = array();
        $boletos = array_values(array_filter($this->retornos, function($item){
            return strtoupper($item->getTipoRegistro()) == self::SEGMENTO_J;
        }));
        return $boletos;
    }

    public function leArquivo($nrorg, $accesStage = false)
    {
        try {
            foreach ($this->arquivo as $linha) {
                if($linha){
                    if (strlen($linha) > 0){

                        $tipoDeRegistroDoArquivo = substr($linha,7,1);
                        switch ($tipoDeRegistroDoArquivo) {
                            case(self::ID_REGISTRO_HEADER):
                                $this->retorno = new Retorno();
                                $this->leHeaderArquivo($linha);
                                $this->retornos[] = $this->retorno;
                                break;
                            case(self::ID_REGISTRO_LOTE):
                                $this->retorno = new Retorno();
                                $this->leHeaderLote($linha);
                                $this->retornos[] = $this->retorno;
                                break;
                            case(self::ID_REGISTRO_TRANSACAO):
                                $this->existeBoleto = 'S';
                                
                                $codigoBanco = substr($linha, 0, 3);
                                if((substr($linha, 13, 1) == self::SEGMENTO_J) && (substr($linha, 17, 2) != '52') && ($codigoBanco == self::CODIGO_COMPENSACAO_BRADESCO))
                                    $this->retorno = new Retorno();
                                    
                                $this->leRegistroDetalhe($linha);
                                
                                if((substr($linha, 13, 1) == self::SEGMENTO_J) && (substr($linha, 17, 2) != '52') && ($codigoBanco == self::CODIGO_COMPENSACAO_BRADESCO))
                                    $this->retornos[] = $this->retorno;
                                break;
                        }
                    }
                }
            }
            if(!$this->existeBoleto){
                if(!$accesStage)
                     throw new \Exception("Não há boletos no arquivo de retorno.", 1);
                else return array('Error' => ('Não há boletos no arquivo de retorno.'));
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    private function leHeaderArquivo($registro){
        $this->cnpjEmpresa = substr($registro, 18, 14);
    }

    private function leHeaderLote($registro){
    }

    private function leRegistroDetalhe($registro){
        $codigoBanco = substr($registro, 0, 3);
            
        if((substr($registro, 13, 1) == self::SEGMENTO_J) && (substr($registro, 17, 2) == '52') && ($codigoBanco == self::CODIGO_COMPENSACAO_BRADESCO)){
            $this->retorno->setTipoRegistro(self::SEGMENTO_J);
            $codigoInscricaoCedente = substr($registro, 19, 1);
            $tipoInscricao = ($codigoInscricaoCedente == self::CPF) ? 'F' : 'J';
            $this->retorno->setTipoInscricao($tipoInscricao);
            // CODIGO VERDADEIRO DO FORNEDOR $this->retorno->setCdforneced(substr($registro, 76, 15));
            $this->retorno->setCdforneced(substr($registro, 77, 14));
            $this->retorno->setNmforneced(substr($registro, 91, 40));
            $this->retorno->setCnpjEmpresa($this->cnpjEmpresa);
        }elseif ((substr($registro, 13, 1) == self::SEGMENTO_J) && ($codigoBanco == self::CODIGO_COMPENSACAO_BRADESCO)){
            
            
            $this->retorno->setTipoRegistro(self::SEGMENTO_J);
            $valorTitulo = floatVal(substr($registro, 99, 13))/100;
            $this->retorno->setVrfinalbpag($valorTitulo); //VALOR NOMINAL DO TÍTULO
            
            $dtvencimento = substr($registro, 91, 2) . '/' . substr($registro, 93, 2) . '/' . substr($registro, 95, 4);
            $this->retorno->setDtvenbolpag($dtvencimento);//DATA DE VENCIMENTO DO TÍTULO
            
            $this->retorno->setCdbarrapag(substr($registro, 17, 44));
            $this->retorno->setCodigoBanco(self::CODIGO_COMPENSACAO_BRADESCO);
            
            // Não existe validação de numero de documento quando for Bradesco
            $this->retorno->setNrnotafisc(trim(substr($registro, 147, 15)));
        }
    }

}